      PROGRAM SRCTREE
C-----------------------------------------------------------------------
C
C  Name         : SRCTREE
C  Version      : 2.0
C  Purpose      : DERIVE TREE STRUCTURE OF SOURCES
C  Author       : W.W.M. Heesbeen
C  Date         : OKT 03 1995
C  Copyright    : National Aerospace Laboratory N.L.R. (VS)
C                 P.O. box 90502
C                 1006 BM Amsterdam, Netherlands
C  Manual       : SRCTREE.DOC
C  Library used : ELMOP.LIB (SDDIR)
C
C-----------------------------------------------------------------------
      IMPLICIT NONE
COMMON/BEGIN/
COMMON/END/

      INTEGER I, J, K, L, FILENUM, NFILES, BLOCK, POINTER, MXLENGTH,
     +        BLOCKPNT(500), LINENUM, MAXELEM, CHRNUM, NUMARG,
     +        NARGS, MAINBLK, ECURBLK(50), BCURBLK(50), LEVEL, NAMEPNT,
     +        LEVELPNT(50), STATE(7), NF, PNT, FUNCPNT, FUNCLEN(500),
     +        MAXLEVEL, FTL(7), NAMETYPE(2000), PNAMEPNT, ENDLINE

      CHARACTER SRCFILE*20, LINE*800, FILELIST(500)*12, NAMES(2000)*20,
     +          CALLNAME*20, ARGUMENT(7)*20, ARGNAME*20, ARG*20,
     +          PROGNAME*20, PROGFILE*20, TREEFILE*20, DIRFILE*20,
     +          DASH*200, EXTEND*20, EXTENDS*30, LN1*2, LN2*2, LN3*2,
     +          LIST(500)*12, NAME*20, PCAPFILE*20, FUNCLIST(500)*20,
     +          FUNCNAME*20, FUNCTYPE(7)*16, FUNCT*16, FEX*4, EXT*4,
     +          NEXTLINE*80

      LOGICAL SPACE, CAPS, FUNCALL, DISABLE

      DATA MXLENGTH, MAXELEM / 20, 2000 /

      DATA FUNCTYPE / 'REAL            ',
     +                'INTEGER         ',
     +                'CHARACTER       ',
     +                'LOGICAL         ',
     +                'COMPLEX         ',
     +                'DOUBLE PRECISION',
     +                'DOUBLE COMPLEX  ' /

      DATA FTL      / 4, 7, 9, 7, 7, 16, 14 /

C-----------------------------------------------------------------------
C  Process
C-----------------------------------------------------------------------

      NUMARG = NARGS()
      IF (NUMARG .LT. 2) THEN
         WRITE(*,*) 'SRCTREE derives the (active) subroutine structure'
         WRITE(*,*) 'and plots the tree chart in a <program>.TRE file.'
         WRITE(*,*) 'Active means that comment lines are left out.'
         WRITE(*,*)
         WRITE(*,*) 'Syntax:'
         WRITE(*,*) 'SRCTREE [program name] [-E[0/Q/F]] [-N#] [-F]',
     +              ' [-S] [-R] [-L]'
         WRITE(*,*)
         WRITE(*,*) '  -E defines file-extensions (default only *.029).'
         WRITE(*,*) '     -E0 includes *.029'
         WRITE(*,*) '     -EF includes *.FOR'
         WRITE(*,*) '     -EQ includes *.Q'
         WRITE(*,*) '     -E0FQ includes all'
         WRITE(*,*) '  -N# defines maximum number of sublevels.'
         WRITE(*,*) '     # can be 0-9 (0 = calls in main only)'
         WRITE(*,*) '  -F  includes calls to FUNCTIONS.'
         WRITE(*,*) '  -S  defines the use of extra spacings.'
         WRITE(*,*) '  -R  defines rectangular/neat lines (for WP).'
         WRITE(*,*) '  -L  forces the use of lower case characters'
         WRITE(*,*) '      for all names (default is CAPITALS).'
         WRITE(*,*)
         WRITE(*,*) 'For more information contact your dealer (Bart).'
         GOTO 999
      ENDIF

      CALL GETARG(1,ARGUMENT(1),STATE(1))
      CALL GETARG(2,ARGUMENT(2),STATE(2))
      CALL GETARG(3,ARGUMENT(3),STATE(3))
      CALL GETARG(4,ARGUMENT(4),STATE(4))
      CALL GETARG(5,ARGUMENT(5),STATE(5))
      CALL GETARG(6,ARGUMENT(6),STATE(6))
      CALL GETARG(7,ARGUMENT(7),STATE(7))


      IF (STATE(1) .LT. 0) GOTO 914
      IF (STATE(1) .LT. 1 .OR. STATE(1) .GT. 8) GOTO 915

C* Default

      EXTEND   = '.029'
      EXTENDS  = '*.029|'
      MAXLEVEL = 50
      LN1      = '| '
      LN2      = '|-'
      LN3      = '\-'
      SPACE    = .FALSE.
      CAPS     = .TRUE.
      FUNCALL  = .FALSE.

C* Check all arguments

      DO I = 2, 7
         ARG = ARGUMENT(I)   

C* Define extensions

         IF (ARG(1:2) .EQ. '-E' .OR. ARG(1:2) .EQ. '-e') THEN
            EXTEND  = ' '
            EXTENDS = ' '
            DO J = 3, 5
               IF (ARG(J:J) .EQ. '0') THEN
                  EXTEND(1:4) = '.029'
                  EXTENDS(1:6) = '*.029|'
               ELSEIF (ARG(J:J) .EQ. 'F' .OR. ARG(J:J) .EQ. 'f') THEN
                  EXTEND(5:12) = '.FOR.for'
                  EXTENDS(7:12) = '*.for|'
               ELSEIF (ARG(J:J) .EQ. 'Q' .OR. ARG(J:J) .EQ. 'q') THEN
                  EXTEND(13:20) = '.Q  .q  '
                  EXTENDS(13:18) = '*.q|  '
               ENDIF
            ENDDO
         ENDIF

C* Limit depth of levels

         IF (ARG(1:2) .EQ. '-N' .OR. ARG(1:2) .EQ. '-n') THEN
            J = ICHAR(ARG(3:3)) - 48
            IF (J .GT. -1 .AND. J .LT. 10) MAXLEVEL = J
         ENDIF

C* Lay out

         IF (ARG(1:2) .EQ. '-R' .OR. ARG(1:2) .EQ. '-r') THEN
            LN1 = ' '
            LN2 = ''
            LN3 = ''
         ENDIF

         IF (ARG(1:2) .EQ. '-S' .OR. ARG(1:2) .EQ. '-s') THEN
            SPACE = .TRUE.
         ENDIF

C* Select lower case

         IF (ARG(1:2) .EQ. '-L' .OR. ARG(1:2) .EQ. '-l') THEN
            CAPS = .FALSE.
         ENDIF

C* Select FUNCTION calls

         IF (ARG(1:2) .EQ. '-F' .OR. ARG(1:2) .EQ. '-f') THEN
            FUNCALL = .TRUE.
         ENDIF
   
      ENDDO

C* Fill DASH

      DO 5 I = 1, 199, 2
         DASH(I:I+1) = LN1
 5    ENDDO

      WRITE(*,*)
      WRITE(*,*) 'Extensions used: ',EXTENDS
      WRITE(*,'(A,I3)') ' Maximum sublevels: ',MAXLEVEL

C* Make list of source files

      NFILES = 0
      DO I = 0, 2
         IF (EXTENDS(1+6*I:6+6*I) .NE. '      ') THEN
            CALL SDDIR(EXTENDS(1+6*I:6+6*I),500,LIST,NF)
            DO J = NFILES+1, NFILES+NF
               FILELIST(J) = LIST(J-NFILES)
            ENDDO
            NFILES = NFILES + NF
         ENDIF
      ENDDO

C* UPPER or lower case

      ARGNAME = ARGUMENT(1)
      IF (CAPS) THEN
         DO 10 I = 1, STATE(1)
            CHRNUM = ICHAR(ARGNAME(I:I))
            IF (CHRNUM .GT. 96 .AND. CHRNUM .LT. 123) THEN
               CHRNUM = CHRNUM - 32
            ENDIF
            ARGNAME(I:I) = CHAR(CHRNUM)
 10      ENDDO
      ELSE
         DO 11 I = 1, STATE(1)
            CHRNUM = ICHAR(ARGNAME(I:I))
            IF (CHRNUM .GT. 64 .AND. CHRNUM .LT. 91) THEN
               CHRNUM = CHRNUM + 32
            ENDIF
            ARGNAME(I:I) = CHAR(CHRNUM)
 11      ENDDO
      ENDIF
      PROGNAME = ARGNAME(1:STATE(1))

C* UPPER case for filename

      DO 12 I = 1, STATE(1)
         CHRNUM = ICHAR(ARGNAME(I:I))
         IF (CHRNUM .GT. 96 .AND. CHRNUM .LT. 123) THEN
            CHRNUM = CHRNUM - 32
         ENDIF
         PCAPFILE(I:I) = CHAR(CHRNUM)
 12   ENDDO

C* Find main source file

      DO 13 I = 0, 4
         IF (EXTEND(1+4*I:4+4*I) .NE. '    ') THEN
            PROGFILE = PCAPFILE(1:STATE(1)) // EXTEND(1+4*I:4+4*I)
            WRITE(*,*) 'Searching for ',PROGFILE
            DO 14 J = 1, NFILES
               IF (PROGFILE .EQ. FILELIST(J)) GOTO 20
 14         ENDDO
         ENDIF
 13   ENDDO
      STOP 'Program source not found in this directory.'

 20   WRITE(*,*) 'Found.'
      WRITE(*,*)
      IF (FUNCALL) THEN

         WRITE(*,*) 'Listing all FUNCTION names.'

         FUNCPNT = 0

         DO 30 FILENUM = 1,NFILES
            SRCFILE = FILELIST(FILENUM)

C* Open files

            LINENUM = 0
            OPEN(10,FILE=SRCFILE,STATUS='OLD',ERR=911)

C* Find FUNCTION

 31         READ(10,'(A)',END=35,ERR=888) NEXTLINE
            LINENUM = LINENUM + 1

            IF (NEXTLINE(1:1).EQ.'C' .OR. NEXTLINE(1:1).EQ.'c') GOTO 31
            IF (INDEX(NEXTLINE, '(') .LT. 1) GOTO 31

C* Capitalize all characters

            DO 32 I = 1, 72
               CHRNUM = ICHAR(NEXTLINE(I:I))
               IF (CHRNUM .GT. 96 .AND. CHRNUM .LT. 123) THEN
                  CHRNUM = CHRNUM - 32
               ENDIF
               NEXTLINE(I:I) = CHAR(CHRNUM)
 32         ENDDO

            I = INDEX(NEXTLINE,'FUNCTION ')
            IF (I .GT. 0 .AND. I .LT. 25) THEN

               IF (I .GT. 7) THEN
                  DO 33 J = 1, 7
                     FUNCT = FUNCTYPE(J)
                     IF (INDEX(NEXTLINE,FUNCT(1:FTL(J))) .EQ. 7) GOTO 36
 33               ENDDO
                  GOTO 39
               ENDIF

 36            I = I + 8
 37            I = I + 1
               IF (I .GT. 72) GOTO 700
               IF (NEXTLINE(I:I) .EQ. ' ') GOTO 37

               J = I - 1
 38            J = J + 1
               IF (J .GT. 72) GOTO 700
               IF(NEXTLINE(J:J).NE.' '.AND.NEXTLINE(J:J).NE.'(') GOTO 38
               J = J - 1
               FUNCNAME = NEXTLINE(I:J)

               DO K = 1, FUNCPNT
                  IF (FUNCNAME .EQ. FUNCLIST(K)) GOTO 39
               ENDDO               

               WRITE(*,*) FUNCNAME
               FUNCPNT = FUNCPNT + 1
               IF (FUNCPNT .GT. 500) GOTO 901
               FUNCLIST(FUNCPNT) = FUNCNAME
               FUNCLEN(FUNCPNT)  = J - I + 1

 39         ENDIF
            GOTO 31
 35         CLOSE (10)
 30      ENDDO
      ENDIF

C* List all subroutines/functions and their calls

      WRITE(*,*)
      IF (FUNCALL) THEN
         WRITE(*,*) 'Listing all SUBROUTINE & FUNCTION calls.'
      ELSE
         WRITE(*,*) 'Listing all SUBROUTINE calls.'
      ENDIF

      BLOCK   = 0
      POINTER = 0

      DIRFILE  = ARGNAME(1:STATE(1)) // '.DIR'
      TREEFILE = ARGNAME(1:STATE(1)) // '.TRE'

C      OPEN(11,FILE=DIRFILE,STATUS='UNKNOWN',ERR=912)
      OPEN(12,FILE=TREEFILE,STATUS='UNKNOWN',ERR=913)

      DO FILENUM = 1,NFILES
         SRCFILE = FILELIST(FILENUM)
         WRITE(*,*) FILELIST(FILENUM)

C* Open files

         OPEN(10,FILE=SRCFILE,STATUS='OLD',ERR=911)

C* Read next line and possible continuations

         READ(10,'(A)',END=200,ERR=888) NEXTLINE
         LINENUM = 0
         
 40      LINE    = NEXTLINE
         ENDLINE = 73
 41      ENDLINE = ENDLINE - 1
         IF (ENDLINE .LE. 8) GOTO 42
         IF (LINE(ENDLINE:ENDLINE) .EQ. ' ') GOTO 41

 42      READ(10,'(A)',END=200,ERR=888) NEXTLINE
         LINENUM = LINENUM + 1

         IF (NEXTLINE(1:1).EQ.'C' .OR. NEXTLINE(1:1).EQ.'c') GOTO 42

C* Check for continuations

         IF (NEXTLINE(6:6) .NE. ' ') THEN
            J = 73
 43         J = J - 1
            IF (NEXTLINE(J:J) .EQ. ' ' .AND. J .GT. 7) GOTO 43

            I = 6
 44         I = I + 1
            IF (NEXTLINE(I:I) .EQ. ' ' .AND. I .LT. J) GOTO 44

            LINE = LINE(1:ENDLINE) // NEXTLINE(I:J)
            ENDLINE = ENDLINE + J - I + 1
            GOTO 42
         ENDIF

C* Capitalize all characters in LINE

         DO 45 I = 1, ENDLINE
            CHRNUM = ICHAR(LINE(I:I))
            IF (CHRNUM .GT. 96 .AND. CHRNUM .LT. 123) THEN
               CHRNUM = CHRNUM - 32
            ENDIF
            LINE(I:I) = CHAR(CHRNUM)
 45      ENDDO

C* Delete leading spaces

         I = 7
 46      IF (LINE(I:I) .EQ. ' ') THEN
            I = I + 1
            IF (I .LT. ENDLINE) GOTO 46
         ENDIF
         LINE = LINE(1:6) // LINE(I:ENDLINE)
         ENDLINE = ENDLINE + 7 - I

C* Find SUBROUTINE

         IF (LINE(7:17) .EQ. 'SUBROUTINE ') THEN
            I = 17
 51         I = I + 1
            IF (I .GT. (17+MXLENGTH)) GOTO 701
            IF (LINE(I:I) .EQ. ' ') GOTO 51
            J = I
 50         I = I + 1
            IF (I .GT. (17+MXLENGTH)) GOTO 701
            IF (LINE(I:I) .NE. ' ' .AND. LINE(I:I) .NE. '(') GOTO 50
            I = I - 1

            DO 52 L = 1, BLOCK
               IF (LINE(J:I) .EQ. NAMES(BLOCKPNT(L)) .AND.
     +             NAMETYPE(BLOCKPNT(L)) .EQ. 2) THEN
                  DISABLE = .TRUE.
                  WRITE(*,*) 'WARNING: Double SUBROUTINE declaration.'
                  WRITE(*,*) 'First declaration is used!'
                  WRITE(*,*) 'SUBROUTINE: ',LINE(J:I)
                  GOTO 110
               ENDIF
 52         ENDDO

            DISABLE = .FALSE.
            BLOCK   = BLOCK + 1
            POINTER = POINTER + 1
            IF (POINTER .GT. MAXELEM) GOTO 900
            BLOCKPNT(BLOCK) = POINTER

            NAMES(POINTER)    = LINE(J:I)
            NAMETYPE(POINTER) = 2
C            WRITE(11,'(A)')
C            WRITE(11,'(A)') LINE(7:I) // ' CALLS TO:'

C* Find PROGRAM

         ELSEIF (LINE(7:14) .EQ. 'PROGRAM ') THEN
            I = 14
 55         I = I + 1
            IF (I .GT. (14+MXLENGTH)) GOTO 701
            IF (LINE(I:I) .EQ. ' ') GOTO 55
            J = I
 56         I = I + 1
            IF (I .GT. (14+MXLENGTH)) GOTO 701
            IF (LINE(I:I) .NE. ' ' .AND. LINE(I:I) .NE. '(') GOTO 56
            I = I - 1

            DO 60 L = 1, BLOCK
               IF (LINE(J:I) .EQ. NAMES(BLOCKPNT(L)) .AND.
     +             NAMETYPE(BLOCKPNT(L)) .EQ. 1) THEN
                  DISABLE = .TRUE.
                  WRITE(*,*) 'WARNING: Double PROGRAM declaration.'
                  WRITE(*,*) 'First declaration is used!'
                  WRITE(*,*) 'PROGRAM: ',LINE(J:I)
                  GOTO 110
               ENDIF
 60         ENDDO

            DISABLE = .FALSE.
            BLOCK   = BLOCK + 1
            POINTER = POINTER + 1
            IF (POINTER .GT. MAXELEM) GOTO 900
            BLOCKPNT(BLOCK) = POINTER

            NAMES(POINTER)    = LINE(J:I)
            NAMETYPE(POINTER) = 1
C            WRITE(11,'(A)')
C            WRITE(11,'(A)') LINE(7:I) // ' CALLS TO:'

         ELSE

C* Find FUNCTION

            I = INDEX(LINE(1:ENDLINE), 'FUNCTION ')
            J = INDEX(LINE(1:ENDLINE), '(')
            IF (I .GT. 0 .AND. I .LT. 25 .AND. J .GT. 0) THEN
               IF (I .GT. 7) THEN
                  DO 62 J = 1, 7
                     FUNCT = FUNCTYPE(J)
                     IF (INDEX(LINE(1:ENDLINE), FUNCT(1:FTL(J)))
     +                   .EQ. 7) GOTO 63
 62               ENDDO
                  GOTO 80
               ENDIF

 63            I = I + 9
               J = I - 1
 70            J = J + 1
               IF (J .GT. ENDLINE+1) GOTO 702
               IF (LINE(J:J).NE.' ' .AND. LINE(J:J).NE.'(') GOTO 70
               J = J - 1

               DO 72 L = 1, BLOCK
                  IF (LINE(I:J) .EQ. NAMES(BLOCKPNT(L)) .AND.
     +                NAMETYPE(BLOCKPNT(L)) .EQ. 4) THEN
                     DISABLE = .TRUE.
                     WRITE(*,*) 'WARNING: Double FUNCTION declaration.'
                     WRITE(*,*) 'First declaration is used!'
                     WRITE(*,*) 'FUNCTION: ',LINE(I:J)
                     GOTO 110
                  ENDIF
 72            ENDDO

               DISABLE = .FALSE.
               BLOCK   = BLOCK + 1
               POINTER = POINTER + 1
               IF (POINTER .GT. MAXELEM) GOTO 900
               BLOCKPNT(BLOCK) = POINTER

               NAMES(POINTER)    = LINE(I:J)
               NAMETYPE(POINTER) = 4
C               WRITE(11,'(A)')
C               WRITE(11,'(A)') LINE(I-9:J) // ' CALLS TO:'
               GOTO 110
            ENDIF
 80         IF (DISABLE) GOTO 110

C* Find SUBROUTINE calls

            I = INDEX(LINE(1:ENDLINE),'CALL ')
            IF (I .NE. 0) THEN

               K = 6
 81            IF (INDEX(LINE(K+1:ENDLINE), CHAR(39)) .GT. 0) THEN
                  J = INDEX(LINE(K+1:ENDLINE), CHAR(39)) + K
                  K = INDEX(LINE(J+1:ENDLINE), CHAR(39)) + J
                  IF (J .LT. I .AND. K .GT. (I+3)) GOTO 120
                  IF (K .GT. 0) GOTO 81
               ENDIF

               I = I + 4
 95            I = I + 1
               IF (I .GT. ENDLINE+1) GOTO 702
               IF (LINE(I:I) .EQ. ' ') GOTO 95

               L = ICHAR(LINE(I:I))
               IF (L .LT. 65 .OR. L .GT. 90) GOTO 120

               J = I - 1
 100           J = J + 1
               IF (J .GT. ENDLINE+1) GOTO702
               IF (LINE(J:J).NE.' ' .AND. LINE(J:J).NE.'(') GOTO 100
               J = J - 1
               CALLNAME = LINE(I:J)
               DO K = BLOCKPNT(BLOCK) , POINTER
                  IF (CALLNAME .EQ. NAMES(K)) GOTO 120
               ENDDO               
               POINTER = POINTER + 1
               IF (POINTER .GT. MAXELEM) GOTO 900
               NAMES(POINTER)    = CALLNAME            
               NAMETYPE(POINTER) = 3
C               WRITE(11,'(A)') '  ' // LINE(I:J)
 120        ENDIF

C* Find FUNCTION calls

            J = INDEX(LINE(1:ENDLINE), '(')
            IF (FUNCALL .AND. J.GT.0) THEN
               DO 130 I = 1, FUNCPNT
                  FUNCNAME = FUNCLIST(I)
                  J = INDEX(LINE(1:ENDLINE), FUNCNAME(1:FUNCLEN(I)))
                  IF (J .GT. 1) THEN
                     L = ICHAR(LINE(J-1:J-1))
                     IF (L .GT. 64 .AND. L .LT. 91) GOTO 130
                     K = J + FUNCLEN(I) - 1
 140                 K = K + 1
                     IF (K .GT. ENDLINE+1) GOTO 130
                     IF (LINE(K:K) .EQ. ' ') GOTO 140
                     IF (LINE(K:K) .EQ. '(') THEN

                        DO 141 L = BLOCKPNT(BLOCK) , POINTER
                           IF (FUNCNAME .EQ. NAMES(L)) GOTO 130
 141                    ENDDO
                        POINTER = POINTER + 1
                        IF (POINTER .GT. MAXELEM) GOTO 900
                        NAMES(POINTER)    = FUNCNAME(1:FUNCLEN(I))
                        NAMETYPE(POINTER) = 5
C                        WRITE(11,'(A)') 'F ' // LINE(J:K-1)
                     ENDIF
                  ENDIF
 130           ENDDO
            ENDIF

 110     ENDIF
         GOTO 40

 200     CLOSE(10)
      ENDDO

      BLOCKPNT(BLOCK+1) = POINTER + 1

C* UPPER or lower case

      IF (CAPS) THEN
         WRITE(*,*) 'Capitalizing all names...'
         DO 201 I = 1, POINTER
            NAME = NAMES(I)
            DO 202 J = 1, 20
               CHRNUM = ICHAR(NAME(J:J))
               IF (CHRNUM .GT. 96 .AND. CHRNUM .LT. 123) THEN
                  CHRNUM = CHRNUM - 32
               ENDIF
               NAME(J:J) = CHAR(CHRNUM)
 202        ENDDO
            NAMES(I) = NAME
 201     ENDDO
      ELSE
         WRITE(*,*) 'Decapatalizing all names...'
         DO 203 I = 1, POINTER
            NAME = NAMES(I)
            DO 204 J = 1, 20
               CHRNUM = ICHAR(NAME(J:J))
               IF (CHRNUM .GT. 64 .AND. CHRNUM .LT. 91) THEN
                  CHRNUM = CHRNUM + 32
               ENDIF
               NAME(J:J) = CHAR(CHRNUM)
 204        ENDDO
            NAMES(I) = NAME
 203     ENDDO
      ENDIF

C* Derive TREE

      WRITE(*,*)
      WRITE(*,*) 'Deriving TREE structure'

C* Extension for FUNCTIONS

      IF (CAPS .AND. FUNCALL) THEN
         FEX = ' (F)'
      ELSEIF (FUNCALL) THEN
         FEX = ' (f)'
      ELSE
         FEX = '    '
      ENDIF

C* Search for PROGRAM in name list

      DO I = 1, BLOCK
         IF (PROGNAME(1:STATE(1)) .EQ. NAMES(BLOCKPNT(I))) GOTO 210
      ENDDO
      STOP 'Program not in list (did you use capitals/lower case?)'

C* Start at main program

 210  MAINBLK = I
      LEVEL   = 0
      NAMEPNT = 0
      WRITE(12,'(A,I3)') 'Maximum sublevels: ',MAXLEVEL
      WRITE(12,*)
      WRITE(12,*) PROGNAME
      WRITE(12,*) LN1

      DO 220 I = BLOCKPNT(MAINBLK) + 1, BLOCKPNT(MAINBLK + 1) - 1
         PNAMEPNT = NAMEPNT
         NAMEPNT  = I
         NAME = NAMES(NAMEPNT)
         PNT  = 21
 212     PNT  = PNT - 1
         IF (PNT .LT. 1) GOTO 920
         IF (NAME(PNT:PNT) .EQ. ' ') GOTO 212

         IF (NAMETYPE(NAMEPNT) .GT. 3) THEN
            EXT = FEX
         ELSE
            EXT = '    '
         ENDIF

         IF (I .LT. BLOCKPNT(MAINBLK + 1) - 1) THEN
            WRITE(12,*) LN2 // NAME(1:PNT) // EXT
         ELSE
            WRITE(12,*) LN3 // NAME(1:PNT) // EXT
            DASH(1:2) = '  '
         ENDIF

C* Find SUBROUTINE or FUNCTION in names

         DO 225 J = 1, BLOCK
            IF (NAMES(BLOCKPNT(J)) .EQ. NAMES(NAMEPNT)) THEN
               IF ((BLOCKPNT(J)+1) .LT. BLOCKPNT(J+1) .AND.
     +             LEVEL .LT. MAXLEVEL .AND. 
     +             PNAMEPNT .NE. (BLOCKPNT(J)+1)) THEN
                  LEVEL = LEVEL + 1
                  LEVELPNT(LEVEL) = BLOCKPNT(J) + 1
                  BCURBLK(LEVEL)  = BLOCKPNT(J) + 1
                  ECURBLK(LEVEL)  = BLOCKPNT(J+1) - 1
                  PNAMEPNT = NAMEPNT
                  NAMEPNT  = LEVELPNT(LEVEL)

C* Loop for sublevels

 300              NAME = NAMES(NAMEPNT)
                  PNT = 21
 310              PNT = PNT - 1
                  IF (PNT .LT. 1) GOTO 920
                  IF (NAME(PNT:PNT) .EQ. ' ') GOTO 310

                  IF (NAMETYPE(NAMEPNT) .GT. 3) THEN
                     EXT = FEX
                  ELSE
                     EXT = '    '
                  ENDIF

                  IF (LEVELPNT(LEVEL) .EQ. ECURBLK(LEVEL)) THEN
                     WRITE(12,*) DASH(1:LEVEL*2) // LN3 //
     +                           NAME(1:PNT) // EXT
                     DASH(LEVEL*2+1:LEVEL*2+2) = '  '
                  ELSEIF (LEVELPNT(LEVEL) .LT. ECURBLK(LEVEL)) THEN
                     WRITE(12,*) DASH(1:LEVEL*2) // LN2 //
     +                           NAME(1:PNT) // EXT
                  ELSE
                     WRITE(*,*) 'ERROR: POINTER > END POINT'
                     STOP 'CONTACT YOUR DEALER!'
                  ENDIF

C* Find SUBROUTINE or FUNCTION in names

                  DO 230 K = 1, BLOCK
                     IF (NAMES(BLOCKPNT(K)) .EQ. NAMES(NAMEPNT)) THEN
                        IF ((BLOCKPNT(K)+1) .LT. BLOCKPNT(K+1) .AND.
     +                      LEVEL .LT. MAXLEVEL .AND. 
     +                      PNAMEPNT .NE. (BLOCKPNT(K)+1)) THEN
                           LEVEL = LEVEL + 1
                           LEVELPNT(LEVEL) = BLOCKPNT(K) + 1
                           PNAMEPNT        = NAMEPNT
                           NAMEPNT         = BLOCKPNT(K) + 1
                           BCURBLK(LEVEL)  = BLOCKPNT(K) + 1
                           ECURBLK(LEVEL)  = BLOCKPNT(K+1) - 1
                           GOTO 300
                        ENDIF
                     ENDIF
 230              ENDDO

C* END OF LEVEL ?

 240              IF (LEVELPNT(LEVEL) .EQ. ECURBLK(LEVEL)) THEN
                     IF (SPACE) WRITE(12,*) DASH(1:LEVEL*2)
 250                 DASH(LEVEL*2+1:LEVEL*2+2) = LN1
                     LEVEL = LEVEL - 1
                     IF (LEVEL .LT. 1) GOTO 220
                     LEVELPNT(LEVEL) = LEVELPNT(LEVEL) + 1
                     NAMEPNT = LEVELPNT(LEVEL)
                     IF (LEVELPNT(LEVEL) .GT. ECURBLK(LEVEL)) GOTO 250
C* NEXT NAME
                  ELSEIF (LEVELPNT(LEVEL) .LT. ECURBLK(LEVEL)) THEN
                     LEVELPNT(LEVEL) = LEVELPNT(LEVEL) + 1
                     NAMEPNT = LEVELPNT(LEVEL)
C* ERROR
                  ELSE
                     WRITE(*,*) 'ERROR: POINTER > END POINT'
                     STOP 'CONTACT YOUR DEALER!'
                  ENDIF

                  GOTO 300

               ENDIF
            ENDIF
 225     ENDDO

 220  ENDDO

C      CLOSE(11)
      CLOSE(12)

      WRITE(*,*) 
      WRITE(*,*) 'SRCTREE complete'
      WRITE(*,*) 'Output in files: ' // TREEFILE

C-----------------------------------------------------------------------
C  Exit & Formats
C-----------------------------------------------------------------------
 999  RETURN
 888  WRITE(*,*) 'Error reading file ',SRCFILE
      STOP
 700  WRITE(*,*) 'FUNCTION NAME NOT FOUND'
      WRITE(*,*) 'FILE: ' // SRCFILE
      WRITE(*,*) 'LINE# ',LINENUM,': ',NEXTLINE
      STOP ' '
 701  WRITE(*,*) 'NAME TOO LONG'
      WRITE(*,*) 'FILE: ' // SRCFILE
      WRITE(*,*) 'LINE# ',LINENUM,': ',LINE(1:ENDLINE)
      STOP ' '
 702  WRITE(*,*) 'NAME NOT FOUND'
      WRITE(*,*) 'FILE: ' // SRCFILE
      WRITE(*,*) 'LINE# ',LINENUM,': ',LINE(1:ENDLINE)
      STOP ' '
 900  STOP 'Maximum number of names exceeded'
 901  STOP 'Maximum number of FUNCTION names exceeded'
 911  WRITE(*,*) 'Error opening file ',SRCFILE
      STOP ' '
 912  STOP 'Error opening SRCTREE.DIR'
 913  STOP 'Error opening SRCTREE.TRE'
 914  STOP 'Name of main program needed'
 915  STOP 'Program-name wrong'
 920  STOP 'Empty name sting??? contact your dealer'
      END